/* GenArray.h */
#ifndef GENARRAY_CLASS
#define GENARRAY_CLASS

#include <LEDA/basic.h>

typedef char* CPtr

/* A dynamic array of total volume = size chars */
class GenArray {
 public:
  /* Q? The two fields below are read-only, how does one enforce it */
  size_t size;
  CPtr ptr;
  
  GenArray();
  GenArray(size_t size);

  /* create a block of sizeof genarray + addsize,
     and copy genarray into me */
  GenArray(GenArray genarray, size_t addsize = 0);
  ~GenArray();
};

#endif
